
// ChildView.h : interface of the CChildView class
//


#pragma once


// CChildView window

class CChildView : public CWnd
{
	// Construction
public:
	CChildView();

	// Attributes
public:
	// The drawing object
	CDrawingObject m_drawingObject;

	// Operations
public:

	// Overrides
protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

	// Implementation
public:
	virtual ~CChildView();

	// Generated message map functions
protected:
	afx_msg void OnPaint();
	DECLARE_MESSAGE_MAP()

	// Needed for drawing object position and size calculations
	double m_dblZoomRatioStart;
	double m_dblZoomRatioTotal;
	CPoint m_ptCenter;
public:
	afx_msg void OnSize(UINT nType, int cx, int cy);

	// Overrides
protected:

	// Gesture handlers
	virtual BOOL OnGestureZoom(CPoint ptCenter, long lDelta);
	virtual BOOL OnGesturePan(CPoint ptFrom, CPoint ptTo);
	virtual BOOL OnGestureRotate(CPoint ptCenter, double dblAngle);
	virtual BOOL OnGesturePressAndTap(CPoint ptFirstFinger, long lDelta);
	virtual BOOL OnGestureTwoFingerTap(CPoint ptCenter);

public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);

// Fields
protected:

	// Holds gesture configuration
	CGestureConfig m_gestureConfig;
};

